import FWCore.ParameterSet.Config as cms

mvaTrigV0 = cms.EDFilter("ElectronIdMVAProducer",
                         verbose = cms.untracked.bool(False),
                         vertexTag = cms.InputTag('offlinePrimaryVertices'),
                         electronTag = cms.InputTag('gsfElectrons'),
                         reducedEBRecHitCollection = cms.InputTag('reducedEcalRecHitsEB'),
                         reducedEERecHitCollection = cms.InputTag('reducedEcalRecHitsEE'),
                         method = cms.string("BDT"),
                         mvaWeightFile = cms.vstring(
    "EgammaAnalysis/ElectronTools/data/Electrons_BDTG_TrigV0_Cat1.weights.xml",
    "EgammaAnalysis/ElectronTools/data/Electrons_BDTG_TrigV0_Cat2.weights.xml",
    "EgammaAnalysis/ElectronTools/data/Electrons_BDTG_TrigV0_Cat3.weights.xml",
    "EgammaAnalysis/ElectronTools/data/Electrons_BDTG_TrigV0_Cat4.weights.xml",
    "EgammaAnalysis/ElectronTools/data/Electrons_BDTG_TrigV0_Cat5.weights.xml",
    "EgammaAnalysis/ElectronTools/data/Electrons_BDTG_TrigV0_Cat6.weights.xml",
    ),
                         Trig = cms.bool(True),
                         NoIP = cms.bool(False),
                         )

mvaTrigNoIPV0 = cms.EDFilter("ElectronIdMVAProducer",
                             verbose = cms.untracked.bool(False),
                             vertexTag = cms.InputTag('offlinePrimaryVertices'),
                             electronTag = cms.InputTag('gsfElectrons'),
                             reducedEBRecHitCollection = cms.InputTag('reducedEcalRecHitsEB'),
                             reducedEERecHitCollection = cms.InputTag('reducedEcalRecHitsEE'),
                             method = cms.string("BDT"),
                             mvaWeightFile = cms.vstring(
    "EgammaAnalysis/ElectronTools/data/Electrons_BDTG_TrigNoIPV0_2012_Cat1.weights.xml",
    "EgammaAnalysis/ElectronTools/data/Electrons_BDTG_TrigNoIPV0_2012_Cat2.weights.xml",
    "EgammaAnalysis/ElectronTools/data/Electrons_BDTG_TrigNoIPV0_2012_Cat3.weights.xml",
    "EgammaAnalysis/ElectronTools/data/Electrons_BDTG_TrigNoIPV0_2012_Cat4.weights.xml",
    "EgammaAnalysis/ElectronTools/data/Electrons_BDTG_TrigNoIPV0_2012_Cat5.weights.xml",
    "EgammaAnalysis/ElectronTools/data/Electrons_BDTG_TrigNoIPV0_2012_Cat6.weights.xml",
    ),
                             Trig = cms.bool(True),
                             NoIP = cms.bool(True),
                             )

mvaNonTrigV0 = cms.EDFilter("ElectronIdMVAProducer",
                            verbose = cms.untracked.bool(False),
                            vertexTag = cms.InputTag('offlinePrimaryVertices'),
                            electronTag = cms.InputTag('gsfElectrons'),
                            reducedEBRecHitCollection = cms.InputTag('reducedEcalRecHitsEB'),
                            reducedEERecHitCollection = cms.InputTag('reducedEcalRecHitsEE'),
                            method = cms.string("BDT"),
                            mvaWeightFile = cms.vstring(
                                  "EgammaAnalysis/ElectronTools/data/Electrons_BDTG_NonTrigV0_Cat1.weights.xml",
                                  "EgammaAnalysis/ElectronTools/data/Electrons_BDTG_NonTrigV0_Cat2.weights.xml",
                                  "EgammaAnalysis/ElectronTools/data/Electrons_BDTG_NonTrigV0_Cat3.weights.xml",
                                  "EgammaAnalysis/ElectronTools/data/Electrons_BDTG_NonTrigV0_Cat4.weights.xml",
                                  "EgammaAnalysis/ElectronTools/data/Electrons_BDTG_NonTrigV0_Cat5.weights.xml",
                                  "EgammaAnalysis/ElectronTools/data/Electrons_BDTG_NonTrigV0_Cat6.weights.xml",
                                  ),
                            Trig = cms.bool(False),
                            NoIP = cms.bool(False),
)
